/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.tidalwave.bluebill.stats.legacyweb;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.filter.LoggingFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.GregorianCalendar;
import java.util.Map;
import java.util.Map.Entry;
import java.util.ResourceBundle;
import javax.annotation.Nonnull;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.core.MediaType;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import lombok.Cleanup;

/**
 *
 * @author fritz
 */
public class PingLegacyServlet extends HttpServlet
  {
    private String statsUrl;

    @Override
    public void init() 
      throws ServletException 
      {
        statsUrl = ResourceBundle.getBundle("Bundle").getString("url");
        log("url: " + statsUrl);
        super.init();
      }
           
    @Override
    protected void doGet (final @Nonnull HttpServletRequest request, final @Nonnull HttpServletResponse response)
      throws ServletException, IOException 
      {
        final @Cleanup PrintWriter writer = response.getWriter();
        
        try
          {
            final StringBuilder jsonBuilder = new StringBuilder();
            jsonBuilder.append("{ ");
            String separator = "";

            for (final Entry<String, String[]> entry : ((Map<String,String[]>)request.getParameterMap()).entrySet())
              {
                jsonBuilder.append(separator);

                String property = entry.getKey();
                final String value = entry.getValue()[0];

                if (property.equals("blueBillVersion"))
                  {
                    property = "appVersion";  
                  }

                jsonBuilder.append('"').append(property).append('"').append(':');
                jsonBuilder.append('"').append(value).append('"');
                separator = ",";
              }

            final XMLGregorianCalendar x = DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar)GregorianCalendar.getInstance());
            jsonBuilder.append(",\"timestamp\":\"").append(x).append("\",");
            jsonBuilder.append("\"ipAddress\":\"").append(request.getRemoteAddr()).append("\" }");
            final Client client = Client.create();
            client.addFilter(new LoggingFilter(System.err));

            final ClientResponse restResponse = client.resource(statsUrl).type(MediaType.APPLICATION_JSON).put(ClientResponse.class, jsonBuilder.toString());
            writer.println("Rest response from " + statsUrl + ": " + restResponse.getStatus());
            writer.println(restResponse.getEntity(String.class));
          }
        catch (Exception e)
          {
            e.printStackTrace(writer);
          }

        response.setStatus(404); // See BBST-28
      }
  }
